# Font-lock support of message bodies was added (Source1) from 
# http://de.geocities.com/ulf_jasper/emacs.html on 10th February 2007.

# Upstream used rather odd versioning: there is a version number, and then a
# "devo" number which is the BZR tree revision, separated with a hypen. However,
# rpm doesn't allow a hyphen in the versoion number.
%define vmversion 8.0.1
%define devoversion 465


%define pkgdir %{_datadir}/emacs/site-lisp/vm
%define pixmapdir %{pkgdir}/pixmaps
%define startd %{_datadir}/emacs/site-lisp/site-start.d/
%define initfile %{startd}/vm-mode-init.el

Summary: Emacs VM mailreader
Name: emacs-vm
Version: %{vmversion}.%{devoversion}
Release: 1%{?dist}
License: GPL
Group: Applications/Internet
URL: http://www.nongnu.org/viewmail/

Source0: http://download.savannah.nongnu.org/releases/viewmail/vm-%{vmversion}-%{devoversion}.tgz
Source1: u-vm-color.el

Requires: emacs
Requires(pre): /sbin/install-info 
Requires(post): /sbin/install-info 
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Buildrequires: emacs texinfo

%description
VM (View Mail) is an Emacs subsystem that allows UNIX mail to be read
and disposed of within Emacs.  Commands exist to do the normal things
expected of a mail user agent, such as generating replies, saving
messages to folders, deleting messages and so on.  There are other
more advanced commands that do tasks like bursting and creating
digests, message forwarding, and organizing message presentation
according to various criteria. 

%package el
Group: Applications/Internet
Summary: Elisp source files for VM mailreader for emacs
Requires: %{name} = %{version}-%{release}

%description el 
The %{name}-el package contains the elisp source files for the %{name}
package. It is not necessary to install this if you want to run vm.

%prep
%setup -q -n vm-%{vmversion}-%{devoversion}

# Add u-vm-color.el and patch Makefile.in to byte compile u-vm-color.el
cp %{SOURCE1} lisp
(cd lisp
mv Makefile.in Makefile.in.bak
sed -e '/SOURCES =/ a SOURCES += u-vm-color.el' Makefile.in.bak > Makefile.in)

%build
export CFLAGS="$RPM_OPT_FLAGS"
%configure
make

%install
rm -rf %{buildroot}

install -d %{buildroot}%{_bindir}
install -d %{buildroot}%{_infodir}

make install \
  prefix=%{buildroot}%{_prefix} \
  bindir=%{buildroot}%{_bindir} \
  info_dir=%{buildroot}%{_infodir}

# Copy source lisp files into buildroot for emacs-vm-el sub-package
(cd lisp ; install -m 644 *.el %{buildroot}%{pkgdir})

# Create initialization file.
install -d %{buildroot}/%{startd}
cat > %{buildroot}/%{initfile} <<EOF
;; Startup settings for VM
(setq vm-toolbar-pixmap-directory "%{pixmapdir}")
(setq vm-image-directory "%{pixmapdir}")
(require 'vm-autoloads)

;; Settings for u-vm-color.el 
(require 'u-vm-color)
(add-hook 'vm-summary-mode-hook 'u-vm-color-summary-mode)
(add-hook 'vm-select-message-hook 'u-vm-color-fontify-buffer)

(defadvice vm-fill-paragraphs-containing-long-lines
    (after u-vm-color activate)
    (u-vm-color-fontify-buffer))
EOF

%clean
rm -rf %{buildroot}

%post 
/sbin/install-info %{_infodir}/vm.info.gz %{_infodir}/dir 2>/dev/null || :

%preun
if [ "$1" = "0" ] ; then 
 /sbin/install-info --delete %{_infodir}/vm.info.gz %{_infodir}/dir 2>/dev/null || :
fi

%files
%defattr(-,root,root,-)
%doc README COPYING
%doc %{_infodir}/*
%{_bindir}/*
%{pixmapdir}
%{pkgdir}/*.elc
%{initfile}
%dir %{pkgdir}

%files el
%defattr(-,root,root,-)
%{pkgdir}/*.el

%changelog
* Thu Jun 28 2007 Jonathan G. Underwood <jonathan.underwood@gmail.com> - 8.0.1.465-1
- Update to bugfix release 8.0.1 (fixes BZ #245780)

* Tue Jun 26 2007 Jonathan G. Underwood <jonathan.underwood@gmail.com> - 8.0.0.453-1
- Ensure files in /usr/bin have exec bit set properly (BZ #245740)

* Tue Jun 19 2007 Jonathan G. Underwood <jonathan.underwood@gmail.com> - 8.0.0.453-1
- Update to version 8.0.0 devo 453 which removes the need for thr vmrf patch
- No longer need to bundle vcard stuff as that is included upstream
- Spec file cleanups
- No longer use separate pixmaps

* Thu May 17 2007 Jonathan G. Underwood <jonathan.underwood@gmail.com> - 7.19.devo282-11
- Fix missnaming of startup file
- Fix changelog entry

* Sun Mar 18 2007 Jonathan G. Underwood <jonathan.underwood@gmail.com> - 7.19.devo282-10
- Fixed error in specification of Source0

* Sun Mar 18 2007 Jonathan G. Underwood <jonathan.underwood@gmail.com> - 7.19.devo282-9
- Redefine version to include vmrf patch version (devo282)
- Remove pointless %%{pkg} macro
- Add new pixmaps with better sizing (still ugly though)
- Renamed the vmrf patch to include the version

* Sat Feb 10 2007 Jonathan G. Underwood <jonathan.underwood@gmail.com> - 7.19-8
- Added u-vm-color.el from http://de.geocities.com/ulf_jasper/emacs.html
- Added vcard support from http://www.splode.com/users/friedman/software/emacs-lisp/
- Fixed name of info files in pre and post scripts

* Sat Feb  3 2007 Jonathan G. Underwood <jonathan.underwood@gmail.com> - 7.19-5
- Add patch from http://www.robf.de/Hacking/elisp/ (resolves bug 224501)
- Ensure CFLAGS="$RPM_OPT_FLAGS" (bug 225101)

* Mon Aug 28 2006 Jonathan G. Underwood <jonathan.underwood@gmail.com> - 7.19-4
- Bump release for FC-6 mass rebuild

* Tue Jun 20 2006 Jonathan G. Underwood <jonathan.underwood@gmail.com> - 7.19-3
- Change group to Applications/Internet
- Add release tag to the Requires for the -el package

* Tue May 23 2006 Jonathan G. Underwood <jonathan.underwood@gmail.com> - 7.19-2
- Clean up spec file

* Fri Sep  2 2005 Jonathan Underwood <jonathan.underwood@gmail.com> - 7.19-1.fc4.jgu
- Initial build
- Generate vm-mode-init.el
- Separate out *.el files into -el package
- Added patch to remove warnings in the decode and encode programs
